﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.IO;
using System.Net.Mail;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        string[] count = new string[99];
        string[] _number = new string[99];
        int i = 0;
        int counter = 0;
        string message;
        int currentVersion = 1;

        // variables for setting prices
        string drinkPriceList;
        string[] drinkPriceArray;
        string droidPriceList;

        // variables for receiving data

        string order;

        // Initialise the EndPoint for the clients
        IPEndPoint ipep;
        Socket newsock;
        IPEndPoint sender;
        EndPoint Remote;
        int[] indexArray;
        int[] offsetArray;
        int index;

        string[] _drink = new string[99];
        string track;
        string stringCost;
        decimal charge;
        string username;
        string password;
        int numItemsInList;

        // for beer orders
        string pulseCount;
        uint amount;
        decimal volume;

        // from the phone
        string number;
        string pin;
        string DroidIP;

        byte[] data = new byte[2048];
        byte[] data2 = new byte[2048];
        decimal total = 0;

        // for loading and saving database
        string path = "C:\\Users\\lgarcia\\Desktop\\";
        string drinkPricePath = "C:\\Users\\lgarcia\\Desktop\\DrinkPrice.txt";
        // for the current date

        DateTime Date;
        int CurrentDay;
        int CurrentMonth;
        int CurrentYear;
        string TodaysDate;

        // for the date in the calendar on the form
        int day;
        int month;
        int year;
        string FullDate;

        public Form1()
        {
            InitializeComponent();
            fileName.Visible = false;
            clearButton.Visible = false;
            ipep = new IPEndPoint(IPAddress.Any, 9050);
            newsock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
            newsock.Bind(ipep);
            sender = new IPEndPoint(IPAddress.Any, 0);
            Remote = (EndPoint)(sender);

            Date = DateTime.Now;
            CurrentDay = Date.Day;
            CurrentMonth = Date.Month;
            CurrentYear = Date.Year;
            TodaysDate = CurrentMonth.ToString() + "_" + CurrentDay.ToString() + "_" + CurrentYear.ToString();

            day = CurrentDate.Value.Day;
            month = CurrentDate.Value.Month;
            year = CurrentDate.Value.Year;
            FullDate = month.ToString() + "_" + day.ToString() + "_" + year.ToString();

            // bring up form for bartneder to set prices
            initializePrices();

            // begin receiving async data
            newsock.BeginReceiveFrom(data, 0, data.Length, SocketFlags.None, ref Remote, new AsyncCallback(ReceiveData), Remote);
        }

        public void clearOrderButton_Click(object sender, EventArgs e)
        {
            //String DrinkSelected = DrinkQueue.Text;
            string drinkSelected = DrinkQueue.Text;


            if (DrinkQueue.SelectedIndex == -1)
            {
                MessageBox.Show("Please select an item first.", "No item selected", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

            else
            {

                int numVal = DrinkQueue.SelectedIndex;
                if (drinkSelected[1] == ' ')
                {
                   
                    drinkSelected = drinkSelected.Substring(6, (drinkSelected.Length - 6));
                }
                else
                {

                    drinkSelected = drinkSelected.Substring(7, (drinkSelected.Length - 7));
                }


                DrinkQueue.Items.RemoveAt(DrinkQueue.SelectedIndex);
                if ((_number[numVal] != "0") & (_number[numVal] != null))
                {

                    sendSMS("Your " + drinkSelected// _drink[Convert.ToInt32(count[numVal])]
                        + " is ready. Please retrieve it at the bar. Make sure to tip your bartender!",
                       "macomber.alex@gmail.com");
                }
                for (int k = numVal; k < counter; k++)
                {
                    count[k] = count[k + 1];
                    _number[k] = _number[k + 1];

                }
                i = i - 1;
            }
        }

        public void ReceiveData(IAsyncResult e)
        {
            this.customersTableAdapter.Fill(this.bartenderDBDataSet.Customers);
            ipep = new IPEndPoint(IPAddress.Any, 0);
            // Initialise the EndPoint for the clients
            Remote = (EndPoint)ipep;
            // Receive all data
            newsock.EndReceiveFrom(e, ref Remote);
            if (Encoding.ASCII.GetString(data, 0, 1) == "!")
            {
                updateDrinks();
                data = new byte[1024];
                newsock.BeginReceiveFrom(data, 0, data.Length, SocketFlags.None, ref Remote, new AsyncCallback(ReceiveData), Remote);
            }
            else
            {
                count[i] = Convert.ToString(counter);
                indexArray = new int[4];
                offsetArray = new int[4];
                //To Write the Order
                index = 0;
                while (data[index] != 0)
                {
                    index = index + 1;
                }
                char[] delimiterChars = { '#', '$', '@', '&' };
                order = Encoding.ASCII.GetString(data, 0, index);
                string[] words = { " " };
                words = order.Split(delimiterChars);

                // this is a drink order from the kiosk
                if (Encoding.ASCII.GetString(data, 0, 1) == "#")
                {
                    // Convert string to int
                    int orderID;
                    int.TryParse(count[i], out orderID);

                    // Add order to datatable Orders (track, drink, number, orderID)
                    //MessageBox.Show(orderID.ToString());
                    //ordersTableAdapter.AddOrder("kiosk", words[1], "fromKiosk", orderID);

                    _drink[i] = words[1];
                    _number[i] = "0";
                    track = words[2];
                    stringCost = words[3];

                    // covert the cost of the mixed drink to a decimal to be added to the total
                    charge = Convert.ToDecimal(stringCost);

                    // send message back to kiosk indicating drink number and current order
                    numItemsInList = DrinkQueue.Items.Count;

                    // Check if customer has a record, if not create one
                    try
                    {
                        if (customersTableAdapter.GetTotal(track) == null)
                        {
                            customersTableAdapter.NewCustomer(track, null, null);
                            //message = "Customer Created in drink order sent from kiosk";
                        }
                        //update index for the counter and drink arrays & update list on bartender
                        i++; counter++; index = 0;
                        updateLabelText(count[i - 1] + "     " + _drink[i - 1]);
                        //updateLabelText(track);
                    }

                    catch (Exception e2)
                    {
                        message = "Customer Not Created In Drink Order Sent From Kiosk";
                        System.Windows.Forms.MessageBox.Show(e2.ToString());
                        MessageBox.Show(message);
                    }

                    // Add charge to total
                    customersTableAdapter.AddToTotal(charge, track);
                    // Get new total                
                    try
                    {
                        total = (decimal)customersTableAdapter.GetTotal(track);
                        message = "Successfully obtained total";
                    }
                    catch (Exception e1)
                    {
                        message = "Total Could Not Be Obtained From Database";
                        System.Windows.Forms.MessageBox.Show(e1.ToString());
                        MessageBox.Show(message);
                    }

                    // Update DataGridView on form
                    customersTableAdapter.Fill(bartenderDBDataSet.Customers);
                    this.tableAdapterManager.UpdateAll(this.bartenderDBDataSet);
                    //send message to customer

                    if (numItemsInList.ToString() == "1")
                    {
                        message = "You Are Order #  " + count[i - 1] + ". \n" + numItemsInList.ToString() + " Order Is In Front of You. " +
                       "\nAmount Charged: $" + stringCost;
                    }
                    else
                    {
                        message = "You Are Order #  " + count[i - 1] + ". \n" + numItemsInList.ToString() + " Orders Are In Front of You. " +
                            "\nAmount Charged: $" + stringCost;
                    }

                    data2 = Encoding.ASCII.GetBytes(message);
                    newsock.SendTo(data2, data2.Length, SocketFlags.None, Remote);
                    // Begin waiting for async data to be sent from client
                    data = new byte[1024];
                    newsock.BeginReceiveFrom(data, 0, data.Length, SocketFlags.None, ref Remote, new AsyncCallback(ReceiveData), Remote);
                }
                // this is a drink order from an Android phone & the database needs to be updated
                else if (Encoding.ASCII.GetString(data, 0, 1) == "&")
                {
                    // number IP username pin drink
                    if (words[1] == "null")
                    {
                        words[1] = "macomber.alex@gmail.com";
                    }
                    number = words[1];
                    _number[i] = words[1];

                    // Convert string to int

                    // Add order to datatable Orders (track, drink, number, orderID)
                    //ordersTableAdapter.AddOrder("phone", words[5],words[1],orderID);

                    DroidIP = words[2];
                    username = words[3];
                    pin = words[4];
                    _drink[i] = words[5];
                    stringCost = words[6];
                    // covert the cost of the mixed drink to a decimal to be added to the total
                    charge = Convert.ToDecimal(stringCost);
                    track = customersTableAdapter.FindTrack(username);

                    // query the database for the username
                    if (customersTableAdapter.CheckUsername(username) != null)
                    {
                        // if the username exists make sure the password is right
                        if (customersTableAdapter.GetPassword(username) == pin)
                        {
                            //check if password is right
                            message = "Password correct";
                            // send message back to droid indicating drink number and current order
                            // the number of drinks in the list in counter
                            sendUDP("1#" + count[i] + "#" + DrinkQueue.Items.Count.ToString() + "#", DroidIP);
                            // only update index values 1if password is correct and order is placed
                            i++; counter++;
                            // charge the username and password
                            updateLabelText(count[i - 1] + "     " + _drink[i - 1]);
                            // Add charge to total
                            customersTableAdapter.AddToTotal(charge, track);
                        }
                        // otherwise the password was not correct
                        else
                        {
                            sendUDP("3#", DroidIP);
                            message = "Password incorrect for existing username";
                        }
                    }

                    // otherwise the username did not exist
                    else
                    {
                        sendUDP("2#", DroidIP);
                        message = "Username does not exist";
                    }
                    //System.Windows.Forms.MessageBox.Show(message);
                    // start to receive async data again      
                    data = new byte[1024];
                    newsock.BeginReceiveFrom(data, 0, data.Length, SocketFlags.None, ref Remote, new AsyncCallback(ReceiveData), Remote);
                }
                // this is a setting up a username with a track number and password
                else if (Encoding.ASCII.GetString(data, 0, 1) == "$")
                {
                    track = words[1];
                    username = words[2];
                    password = words[3];

                    // Check if customer has a record, if not create one
                    try
                    {
                        // check if the user already has an account
                        if (customersTableAdapter.GetTrack(track) != null)
                        {
                            // check if the customer does not have a username yet
                            if (customersTableAdapter.GetUsername(track) == null)
                            {
                                // if they don't have a username, check to make sure username is unique
                                if (customersTableAdapter.CheckUsername(username) == null)
                                {
                                    customersTableAdapter.SetUsername(username, password, track);
                                    message = ("UserName Updated");
                                }
                                // if it's not unique don't create username
                                else
                                {
                                    message = "UserName already taken for account already in existence";
                                    //System.Windows.Forms.MessageBox.Show("UserName Updated");
                                }
                            }
                            // otherwise they already have a username, do not change it
                            else
                            {
                                message = "You already have a username: It is: " + customersTableAdapter.GetUsername(track);
                                //System.Windows.Forms.MessageBox.Show(message2);
                            }
                        }
                        // otherwise it is a first time user, an account needs to be created
                        else if (customersTableAdapter.GetTrack(track) == null)
                        {
                            // check if the username is unique
                            if (customersTableAdapter.CheckUsername(username) == null)
                            {
                                //allow for creation of username
                                customersTableAdapter.NewCustomer(track, username, password);
                                message = "Username Created";
                            }
                            // otherwise the username is taken, do not create the username
                            else
                            {
                                message = "Username already in Use, Please Select Another";
                            }
                        }
                    }
                    catch
                    {
                        message = "Unable to complete try statement for creating username and password";
                    }
                    // System.Windows.Forms.MessageBox.Show(message);

                    data2 = Encoding.ASCII.GetBytes(message);
                    newsock.SendTo(data2, data2.Length, SocketFlags.None, Remote);

                    // Update Datagrid view on form
                    customersTableAdapter.Fill(bartenderDBDataSet.Customers);
                    this.tableAdapterManager.UpdateAll(this.bartenderDBDataSet);

                    // start receiving async data again
                    data = new byte[1024];
                    newsock.BeginReceiveFrom(data, 0, data.Length, SocketFlags.None, ref Remote, new AsyncCallback(ReceiveData), Remote);
                }
                // this is a beer order
                else if (Encoding.ASCII.GetString(data, 0, 1) == "@")
                {
                    track = words[1];
                    pulseCount = words[2];
                    if (pulseCount == "")
                    {
                        pulseCount = "0";
                    }
                    // convert the pulse count from a string to an unsigned int, then convert to volume in ml, get that as a decimal
                    amount = Convert.ToUInt32(pulseCount);
                    volume = Convert.ToDecimal(amount / 165.61176);
                    // determine the price of the volume poured
                    if (track[1].ToString() == "0")
                    {
                        charge = Convert.ToDecimal(0);
                    }
                    else
                    {
                        charge = volume * Convert.ToDecimal(drinkPriceArray[13]);
                    }
                    string stringCost = charge.ToString();
                    index = 0;
                    // Check if customer has a record, if not create one
                    try
                    {
                        if (customersTableAdapter.GetTotal(track) == null)
                        {
                            customersTableAdapter.NewCustomer(track, null, null);
                            message = "Customer created for beer order";
                        }
                    }
                    catch
                    {
                        message = "Could not create customer for beer order";
                    }
                    //  System.Windows.Forms.MessageBox.Show(message);

                    //System.Windows.Forms.MessageBox.Show(message);
                    // Add charge to total
                    customersTableAdapter.AddToTotal(charge, track);
                    // Get new total                
                    try
                    {
                        total = (decimal)customersTableAdapter.GetTotal(track);
                        message = "Total retrieved for customer";
                    }
                    catch
                    {
                        message = "Could not retrieve total for customer";
                    }
                    message = "You've Just Added $" + (Math.Round(charge, 2)).ToString() + " For A Night's Total of $" + (Math.Round(total, 2)).ToString();

                    data2 = Encoding.ASCII.GetBytes(message);
                    newsock.SendTo(data2, data2.Length, SocketFlags.None, Remote);
                    // send message back to user
                    //System.Windows.Forms.MessageBox.Show(message);
                    // Update DataGridView on form
                    customersTableAdapter.Fill(bartenderDBDataSet.Customers);
                    this.tableAdapterManager.UpdateAll(this.bartenderDBDataSet);
                    data = new byte[1024];
                    newsock.BeginReceiveFrom(data, 0, data.Length, SocketFlags.None, ref Remote, new AsyncCallback(ReceiveData), Remote);
                }

            }


        }

        delegate void updateLabelTextDelegate(string newText);
        private void updateLabelText(string newText)
        {
            if (DrinkQueue.InvokeRequired)
            {
                // this is worker thread
                updateLabelTextDelegate del = new updateLabelTextDelegate(updateLabelText);
                //label1.Invoke(del, new object[] {"You have poured " + newText + " ounces" });
                DrinkQueue.Invoke(del, new object[] { newText });
            }
            else
            {
                // this is UI thread
                DrinkQueue.Items.Add(newText);
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            customersTableAdapter.ClearTable();
            // TODO: This line of code loads data into the 'bartenderDBDataSet.Customers' table. You can move, or remove it, as needed.
            this.customersTableAdapter.Fill(this.bartenderDBDataSet.Customers);

        }

        private void LoadButton_Click(object sender, EventArgs e)
        {
            this.Refresh();
            Thread.Sleep(20);

            fileName.Visible = true;
            saveButton.Visible = false;

            // before loading new file, save file for the current date
            string filename = path + TodaysDate + ".txt";
            if (!(File.Exists(filename)))
            {
                // Save data to fileName in XML format
                bartenderDBDataSet.WriteXml(filename);
                bartenderDBDataSet.Dispose();
                // Delete all rows from table
                customersTableAdapter.ClearTable();
                // Update DataGridView
                customersTableAdapter.Fill(bartenderDBDataSet.Customers);
            }
            else
            {
                filename = path + TodaysDate + "_" + currentVersion.ToString() + ".txt";
                // Save data to fileName in XML format
                bartenderDBDataSet.WriteXml(filename);
                bartenderDBDataSet.Dispose();
                // Delete all rows from table
                customersTableAdapter.ClearTable();
                // Update DataGridView
                customersTableAdapter.Fill(bartenderDBDataSet.Customers);
                currentVersion = currentVersion + 1;

            }

            // Get current date from calender
            // day = CurrentDate.Value.Day;
            //month = CurrentDate.Value.Month;
            //year = CurrentDate.Value.Year;
            //FullDate = month.ToString() + "_" + day.ToString() + "_" + year.ToString();

            MessageBox.Show("Enter File Name In Text Box");


        }

        private void saveButton_Click(object sender, EventArgs e)
        {
            this.Refresh();
            Thread.Sleep(20);
            // Define file to write data to, 
            string fileName = path + TodaysDate + ".txt";

            if (getDate()) // if todays date and the day on the calendar are the same, save the file
            {
                if (File.Exists(fileName)) // if file exists, save to new file
                {
                    fileName = path + TodaysDate + "_" + currentVersion.ToString() + ".txt";
                    // Save data to fileName in XML format
                    bartenderDBDataSet.WriteXml(fileName);
                    bartenderDBDataSet.Dispose();
                    currentVersion = currentVersion + 1;
                    customersTableAdapter.ClearTable();
                    // Update DataGridView
                    customersTableAdapter.Fill(bartenderDBDataSet.Customers);
                }
                else // else save to file with current date
                {
                    // Save data to fileName in XML format
                    bartenderDBDataSet.WriteXml(fileName);
                    bartenderDBDataSet.Dispose();
                    // Delete all rows from table
                    customersTableAdapter.ClearTable();
                    // Update DataGridView
                    customersTableAdapter.Fill(bartenderDBDataSet.Customers);
                }
            }
            else if (!getDate()) //if todays date and day on calendar are different, do not save current table
            {
                System.Windows.Forms.MessageBox.Show("You may not save data for a different date than the current date");
            }
        }

        private bool getDate()
        {
            day = CurrentDate.Value.Day;
            month = CurrentDate.Value.Month;
            year = CurrentDate.Value.Year;
            FullDate = month.ToString() + "_" + day.ToString() + "_" + year.ToString();

            CurrentDay = Date.Day;
            CurrentMonth = Date.Month;
            CurrentYear = Date.Year;
            TodaysDate = CurrentMonth.ToString() + "_" + CurrentDay.ToString() + "_" + CurrentYear.ToString();

            if (TodaysDate == FullDate)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        public void sendUDP(string messageToDroid, string ipAddress)
        {
            IPEndPoint ipep;
            //string ipAddress = "10.40.167.147";
            int portNumber = 9050;
            data = new byte[1024];
            ipep = new IPEndPoint(IPAddress.Parse(ipAddress), portNumber);
            Socket server = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);

            // convert amount to string to send to server
            data = Encoding.ASCII.GetBytes(messageToDroid);
            // try sending the order to the bartender
            try
            {
                server.SendTo(data, data.Length, SocketFlags.None, ipep);
            }
            catch (SocketException ex)
            {
                string message = ex.Message;
                System.Windows.Forms.MessageBox.Show(message);
            }
        }


        public void sendSMS(string textBody, string number)
        {
            /*if (number != "macomber.alex@gmail.com")
            { 
                    MailMessage message = new MailMessage();
                    number = number + "@vtext.com";
                    message.From = new MailAddress("AutoBev@gmail.com", "AutoBev");
                    message.To.Add(number);
                    message.Subject = "AutoBev: Your drink is ready";
                    message.Body = textBody;

                    SmtpClient smtp = new SmtpClient("smtp.gmail.com");
                    smtp.UseDefaultCredentials = false;
                    smtp.Credentials = new NetworkCredential("AutoBev@gmail.com", "NotreDame"); //NotreDame is the password of the AutoBev@gmail.com

                    smtp.EnableSsl = true;
                    smtp.Port = 587;
                    smtp.DeliveryMethod = SmtpDeliveryMethod.Network;
                    try
                    {
                        smtp.Send(message);
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show(ex.Message);
                    }
                    number = "eclark4@nd.edu";
            }*/

            MailMessage messageText = new MailMessage();
            messageText.From = new MailAddress("AutoBev@gmail.com", "AutoBev");
            messageText.To.Add(number);
            messageText.Subject = "AutoBev: Your drink is ready";
            messageText.Body = textBody;

            SmtpClient smtpText = new SmtpClient("smtp.gmail.com");
            smtpText.UseDefaultCredentials = false;
            smtpText.Credentials = new NetworkCredential("AutoBev@gmail.com", "NotreDame"); //NotreDame is the password of the AutoBev@gmail.com

            smtpText.EnableSsl = true;
            smtpText.Port = 587;
            //smtp.DeliveryMethod = SmtpDeliveryMethod.SpecifiedPickupDirectory;
            // smtp.DeliveryMethod = SmtpDeliveryMethod.PickupDirectoryFromIis;//
            smtpText.DeliveryMethod = SmtpDeliveryMethod.Network;
            try
            {
                smtpText.Send(messageText);
                //  System.Windows.Forms.MessageBox.Show("message sent:"+message);

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

        }


        public void updatePricesButton_Click(object sender, EventArgs e)
        {
            DrinkPrices dp = new DrinkPrices();
            dp.ShowDialog();
            decimal[] drinkPrices = new decimal[7];

            TextReader tr = new StreamReader("C:\\Users\\lgarcia\\Desktop\\DrinkPrice.txt");

            //while (tr.Peek() > -1)
            //{
            // read a line of text
            char[] delimiterChar = { '/' };
            drinkPriceList = tr.ReadLine();
            drinkPriceArray = drinkPriceList.Split(delimiterChar);
            droidPriceList = "4#" + drinkPriceArray[0] + "#" + drinkPriceArray[1] + "#" + drinkPriceArray[2] + "#" + drinkPriceArray[3] + "#" + drinkPriceArray[4] +
                "#" + drinkPriceArray[4] + "#" + drinkPriceArray[5] + "#" + drinkPriceArray[6] + "#" + drinkPriceArray[7] + "#" + drinkPriceArray[8] + "#" + drinkPriceArray[9] +
                "#" + drinkPriceArray[10] + "#" + drinkPriceArray[11] + "#";

            tr.Close();
        }

        public void initializePrices()
        {
            DrinkPrices dp = new DrinkPrices();
            dp.ShowDialog();
            decimal[] drinkPrices = new decimal[7];
            TextReader tr = new StreamReader(drinkPricePath);
            char[] delimiterChar = { '/' };
            drinkPriceList = tr.ReadLine();
            drinkPriceArray = drinkPriceList.Split(delimiterChar);
            droidPriceList = "4#" + drinkPriceArray[0] + "#" + drinkPriceArray[1] + "#" + drinkPriceArray[2] + "#" + drinkPriceArray[3] + "#" + drinkPriceArray[4] +
                "#" + drinkPriceArray[4] + "#" + drinkPriceArray[5] + "#" + drinkPriceArray[6] + "#" + drinkPriceArray[7] + "#" + drinkPriceArray[8] + "#" + drinkPriceArray[9] +
                "#" + drinkPriceArray[10] + "#" + drinkPriceArray[11] + "#";
            tr.Close();
        }

        public void updateDrinks()
        {
            string message = drinkPriceList;
            data2 = Encoding.ASCII.GetBytes(message);
            data = new byte[1024];
            newsock.SendTo(data2, data2.Length, SocketFlags.None, Remote);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Refresh();
        }

        private void clearButton_Click(object sender, EventArgs e)
        {
            customersTableAdapter.ClearTable();
            // Update DataGridView
            customersTableAdapter.Fill(bartenderDBDataSet.Customers);
            clearButton.Visible = false;
            saveButton.Visible = true;
        }



        private void fileName_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                string FileName = path + fileName.Text + ".txt";
                // check to see if the file exists
                if (File.Exists(FileName))
                { // if it does, load it            
                    // Read data from fileName in XML format
                    customersTableAdapter.ClearTable();
                    customersTableAdapter.Fill(bartenderDBDataSet.Customers);
                    bartenderDBDataSet.ReadXml(FileName);
                    // Update DataGridView on form
                    //  customersTableAdapter.Fill(db_4_1DataSet.customers);
                    fileName.Visible = false;
                    clearButton.Visible = true;
                    saveButton.Visible = false;
                }
                //otherwise tell the user that the file does no exist
                else
                {
                    System.Windows.Forms.MessageBox.Show("File For Selected Date Has Not Been Created Yet");
                }

            }


        }

        private void customersDataGridView_DataError(object sender, DataGridViewDataErrorEventArgs anError)
        {

            //MessageBox.Show("Error happened " + anError.Context.ToString());

            if (anError.Context == DataGridViewDataErrorContexts.Commit)
            {
                MessageBox.Show("Commit error");
            }
            if (anError.Context == DataGridViewDataErrorContexts.CurrentCellChange)
            {
                MessageBox.Show("Cell change");
            }
            if (anError.Context == DataGridViewDataErrorContexts.Parsing)
            {
                MessageBox.Show("parsing error");
            }
            if (anError.Context == DataGridViewDataErrorContexts.LeaveControl)
            {
                MessageBox.Show("leave control error");
            }

            if ((anError.Exception) is ConstraintException)
            {
                DataGridView view = (DataGridView)sender;
                view.Rows[anError.RowIndex].ErrorText = "an error";
                view.Rows[anError.RowIndex].Cells[anError.ColumnIndex].ErrorText = "an error";

                anError.ThrowException = false;
            }
        }

        private void closeButton_Click(object sender, EventArgs e)
        {
            this.Close();
        }

    }
}